'From Squeak 2.4c of May 10, 1999 on 26 July 1999 at 7:17:33 pm'!
'From Squeak 2.4c of May 10, 1999 on 25 July 1999 at 9:18:52 am'!
'From Squeak 2.4b of April 23, 1999 on 16 July 1999 at 5:59:02 pm'!
Object subclass: #Comanche
	instanceVariableNames: 'queue modules status process threads '
	classVariableNames: 'Queues Servers '
	poolDictionaries: ''
	category: 'Comanche'!
Object subclass: #ComancheModule
	instanceVariableNames: 'name tempDir workDir status parent modules '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche'!
ComancheModule subclass: #AccessControlModule
	instanceVariableNames: 'accessControlList '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche'!
ComancheModule subclass: #DomainFilterModule
	instanceVariableNames: 'allowedDomains deniedDomains '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche'!
ComancheModule subclass: #FileServerModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche'!
ConnectionQueue subclass: #HttpConnectionQueue
	instanceVariableNames: 'server block '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche'!
Object subclass: #HttpRequest
	instanceVariableNames: 'header body method protocol url getFields postFields stream responseHeader cookies contentType '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche'!
HttpRequest subclass: #FileServerRequest
	instanceVariableNames: 'filename '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche'!
Object subclass: #HttpResponse
	instanceVariableNames: ''
	classVariableNames: 'StatusCodeDict '
	poolDictionaries: ''
	category: 'Comanche'!
Stream subclass: #HttpStream
	instanceVariableNames: 'socket header status buffer inDataCount outDataCount '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche'!
ComancheModule subclass: #LogModule
	instanceVariableNames: 'logfile '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche'!
Object subclass: #MIMEDocument
	instanceVariableNames: 'mainType subType content url '
	classVariableNames: 'MIMEdatabase '
	poolDictionaries: ''
	category: 'Network-Url'!
ComancheModule subclass: #MultipartPostModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche'!
ComancheModule subclass: #PingModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche'!
FileServerModule subclass: #PwsModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche'!
HttpRequest subclass: #PwsRequest
	instanceVariableNames: 'peerName userId message fields log action '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche'!
!Comanche commentStamp: '<historical>'!
Comanche

a new web server for Squeak

The simultaneous connections are handled by HttpConnectionQueue
Comanche is not instantiated, but used for Server management and accounting
All processing happens inside ComancheModule (and subclasses) instances

HttpStream and HttpRequest handle incoming HTTP data
HttpResponse is used for outgoing HTTP data

When a connection is initiated, the root module is started with httpStartOnSocket:
which in turn produces an HttpRequest from the socket and calls process:

Module process: attempts to convert the HttpRequest to its "native" request format
If it fails, the request cannot be handled by the module
If a module handles the request, the request is processed as follows:
- module performs preprocessing
- each of its children modules do process: (see above - recursive)
- module performs postprocessing

A module may determine that its handling takes care of the request
and no further processing is needed

This component-based model allows easy combination of simple modules
into a powerful super-module (as in super-man)
- case study: a Swiki
  - Swiki = as parent
    - bare bones (search is outsourced)
  - FileServer
    - mini-FTP
    - provides uploads
  - SearchEngine
    - search the index and return a results page
    - using the parent's index
  - SpellChecking

Each module optionally supports persistence.

Big TODO list
- make pluggable:
  - formatters - HTML, VRML, email, etc.
  - templates - regular, rendering, cached, etc.
  - spellers - to select languages, professions
  - externalizers/persistence - to choose among formats - XML, RefStream, etc.
!
!Comanche class reorganize!
('initialize-release' initialize)
('accessing' serverOnPort: servers)
('management' addModule:toServerOnPort: defaultPriority httpdStartOnPort: httpdStopOnPort: startOnPort:package:)
!
!Comanche class methodsFor: 'initialize-release'!
initialize
	Servers _ Dictionary new.
	Queues _ Dictionary new! !
!Comanche class methodsFor: 'accessing'!
serverOnPort: n
	^Servers at: n ifAbsent: []! !
!Comanche class methodsFor: 'accessing'!
servers
	^Servers! !
!Comanche class methodsFor: 'management'!
addModule: module toServerOnPort: n
	(Servers includesKey: n) ifFalse: [self error: 'No server on port ', n asString].

	"(Servers at: n) registerModule: module"! !
!Comanche class methodsFor: 'management'!
defaultPriority
	^Processor userInterruptPriority

	" can also use: "
	" SystemRockBottomPriority _ 1. "
	" SystemBackgroundPriority _ 2. "
	" UserBackgroundPriority _ 3. "
	" UserSchedulingPriority _ 4. "
	" UserInterruptPriority _ 5. "
	" LowIOPriority _ 6. "
	" HighIOPriority _ 7. "
	" TimingPriority _ 8 "

	"from: ProcessorScheduler initialize."! !
!Comanche class methodsFor: 'management'!
httpdStartOnPort: n
	" start the server "
	" TODO: provide two versions - bare and loaded "
	" bare will start the server without any modules "
	" loaded will include FileServer module, plus more "

	| queue httpdThread block server |

	((Servers includesKey: n) or: [Queues includesKey: n])
		ifTrue: [(self confirm: 'There''s already a server on port ', n asString, '. Replace?')
					ifFalse: [^nil].
				self httpdStopOnPort: n].

	Socket initializeNetwork.
	block _ [:httpd :socket |
"		httpdThread _ [[httpd startOnSocket: socket] ifError: [:err :rcvr | #ignore] ] newProcess. "
		httpdThread _ [httpd startOnSocket: socket] newProcess.
		httpdThread priority: self defaultPriority.
		httpdThread resume ].
	server _ ComancheModule new initialize.
	queue _ HttpConnectionQueue portNumber: n queueLength: 4
		server: server block: block.
	Servers at: n put: server.
	Queues at: n put: queue.! !
!Comanche class methodsFor: 'management'!
httpdStopOnPort: n
	(Servers includesKey: n)
		ifTrue: [Servers removeKey: n].
	(Queues includesKey: n)
		ifTrue: [(Queues at: n) destroy. Queues removeKey: n].
! !
!Comanche class methodsFor: 'management'!
startOnPort: n package: packageName
	" start the server "
	" TODO: provide two versions - bare and loaded "
	" bare will start the server without any modules "
	" loaded will include FileServer module, plus more "

	| queue httpdThread block server |

	((Servers includesKey: n) or: [Queues includesKey: n])
		ifTrue: [(self confirm: 'There''s already a server on port ', n asString, '. Replace?')
					ifFalse: [^nil].
				self httpdStopOnPort: n].

	((packageName asString endsWith: 'WebServer') and: [ComancheModule respondsTo: packageName])
		ifFalse: [^self error: 'Invalid package'].

	Socket initializeNetwork.
	block _ [:httpd :socket |
"		httpdThread _ [[httpd startOnSocket: socket] ifError: [:err :rcvr | #ignore] ] newProcess. "
		httpdThread _ [httpd startOnSocket: socket] newProcess.
		httpdThread priority: self defaultPriority.
		httpdThread resume ].
	server _ ComancheModule perform: packageName.
	queue _ HttpConnectionQueue portNumber: n queueLength: 4
		server: server block: block.
	Servers at: n put: server.
	Queues at: n put: queue.! !
!ComancheModule commentStamp: '<historical>'!
ComancheModule

a module is a component that can be part of another module

each module can have peer modules and children modules

peer modules can be shared among modules
- for things like authorization, accounting, logging
- they can influence the way a module processes the request
  - e.g., authorization module returns an error, thus terminate

children modules provide value added services
- e.g., formatting, spell checking!
!ComancheModule reorganize!
('accessing' directory modules name)
('private' privName: privTempDirNamed: privWorkDirNamed: tempDir)
('initialization' initialize)
('processing' filter: handleError:forReceiver: process: processAfterModules: processBeforeModules: processModules: startOnSocket:)
('permissions' checkAuthorization: isAuthorized:toDo:)
('persistence' readFrom: writeOn:)
('http stuff' httpVersion)
('obsolete' processGet: processPost: processPostFormData: processPostMultipart: processPostUnknown: processPut:)
!
!ComancheModule methodsFor: 'accessing'!
directory
	^workDir! !
!ComancheModule methodsFor: 'accessing'!
modules
	^modules! !
!ComancheModule methodsFor: 'accessing'!
name
	^name! !
!ComancheModule methodsFor: 'private'!
privName: str
	name _ str! !
!ComancheModule methodsFor: 'private'!
privTempDirNamed: path
	tempDir _ FileDirectory on: path! !
!ComancheModule methodsFor: 'private'!
privWorkDirNamed: path
	workDir _ FileDirectory on: path! !
!ComancheModule methodsFor: 'private'!
tempDir
	^tempDir! !
!ComancheModule methodsFor: 'initialization'!
initialize
	modules _ OrderedCollection new.! !
!ComancheModule methodsFor: 'processing'!
filter: request
	" determine if this module handles request "
	^request! !
!ComancheModule methodsFor: 'processing'!
handleError: err forReceiver: rcvr
	" Return value "
	" nil = error not handled "
	" smth else = error handled, returning result "
	" -- e.g., return a loggable description "

	^nil! !
!ComancheModule methodsFor: 'processing'!
process: rawRequest
	" standard module processing "
	" PRE: rawRequest is-a HttpRequest "
	" POST: returns HttpRequest "
	| request |
" DEBUG "
self class name asString displayAt: 10@10.

	" check if I handle this rawRequest "
	(request _ self filter: rawRequest)
		ifNil: [^rawRequest].

" DEBUG "
request asString displayAt: 10@50.
request method asString displayAt: 10@70.

	request _ self processBeforeModules: request.
	request _ self processModules: request.
	request _ self processAfterModules: request.

" TODO: Processor yield - to let others run "

	^request! !
!ComancheModule methodsFor: 'processing'!
processAfterModules: request
	^request! !
!ComancheModule methodsFor: 'processing'!
processBeforeModules: request
	^request! !
!ComancheModule methodsFor: 'processing'!
processModules: request
	| aReq |
	aReq _ request.
	modules do: [:m | aReq _ m process: aReq. aReq done ifTrue: [^aReq]].
	^aReq! !
!ComancheModule methodsFor: 'processing'!
startOnSocket: s
	" process the request on the socket "
	" this method is launched in a separate thread for each request "
	| req |
	req _ HttpRequest on: s.
	self process: req.
	req destroy.! !
!ComancheModule methodsFor: 'permissions'!
checkAuthorization: request
	" return the access control "
	" including user (if any), permissions "
	^true! !
!ComancheModule methodsFor: 'permissions'!
isAuthorized: request toDo: action
	" check authorization for a particular action "
	^false! !
!ComancheModule methodsFor: 'persistence'!
readFrom: aStream
	" implement persistence "! !
!ComancheModule methodsFor: 'persistence'!
writeOn: aStream
	" implement persistence "! !
!ComancheModule methodsFor: 'http stuff'!
httpVersion
	" version of HTTP supported "

	^'HTTP/1.1'! !
!ComancheModule methodsFor: 'obsolete'!
processGet: request
	" do something "! !
!ComancheModule methodsFor: 'obsolete'!
processPost: request
request contentType asString displayAt: 10@110.

	request contentType = MIMEDocument contentTypeFormData
		ifTrue: [^self processPostFormData: request].

	request contentType = MIMEDocument contentTypeMultipart
		ifTrue: [^self processPostMultipart: request].

	self processPostUnknown: request! !
!ComancheModule methodsFor: 'obsolete'!
processPostFormData: request
	" use HttpStream's stuff "! !
!ComancheModule methodsFor: 'obsolete'!
processPostMultipart: request
	" return the Dictionary "
	" for regular fields, key->value "
	" for file fields, key=filename->value=tempFilename/MIMEDocument "

" TODO: change from using socket to stream "
" TODO: use unique temporary names "
" TODO: save other form data "
" TODO: return MIMEDocument or FileStream
	(or smth with both temp file name, file type) "

	" save files in the temporary directory, with temporary names "

	| hdr body boundary str idx fileName file fieldName contentType formDict |
"Transcript show: 'socketDataCount = ', request socketDataCount asString; cr."
	formDict _ Dictionary new.
	boundary _ request multipartFormDataBoundary.
Transcript show: 'Boundary = ', boundary; cr.
	[hdr _ request stream getSubHeader.
	(hdr isNil or: [hdr isEmpty]) ifTrue: [^formDict].
Transcript show: hdr asString; cr.
	str _ (hdr at: 'content-disposition' ifAbsent: ['']).

	fileName _ fieldName _ ''.

	idx _ str findString: 'filename='.
	idx > 0 ifTrue: [fileName _ str copyFrom: idx + 10 to: (str indexOf: $" startingAt: idx+10) - 1].

	idx _ str findString: 'name='.
	idx > 0 ifTrue: [fieldName _ str copyFrom: idx + 6 to: (str indexOf: $" startingAt: idx+6) - 1].

	contentType _ hdr at: 'content-type' ifAbsent: [MIMEDocument defaultContentType].
Transcript show: 'field=', fieldName; cr; show: 'file=', fileName; cr;
	show: 'content-type=', contentType; cr.

	fileName size > 0
		ifTrue: [fileName _ (fileName findTokens: ':/\') last.
			fileName _ (FileDirectory checkName: fileName fixErrors: true) asLowercase.
			file _ tempDir fileNamed: fileName]
		ifFalse: [file _ WriteStream on: String new].
" TODO: parse regular form data "
" TODO: create IgnoreStream "

Transcript show: 'reading body...'; cr.
	body _ request stream nextChunk.
" Transcript show: 'init body=', body; cr. "
	[(idx _ body findString: boundary) = 0]
		whileTrue:
			[idx _ body size - boundary size + 1 max: 1.
" Transcript show: 'idx=', idx asString; cr. "
			str _ request stream nextChunk.
" Transcript show: 'str=', str; cr;
	show: 'file=', (body copyFrom: 1 to: idx); cr. "
			file nextPutAll: (body copyFrom: 1 to: idx - 1).
			body _ (body copyFrom: idx to: body size) , str].
	" save the last chunk in the file "
	file nextPutAll: (body copyFrom: 1 to: idx-5). " idx-1 - String crlf size "
	file close.
	formDict at: fieldName put: fileName.

	request stream putDataBack: (body copyFrom: idx-4 to: body size).
	request stream atEnd or: [hdr isNil]
	] whileFalse.

	^formDict! !
!ComancheModule methodsFor: 'obsolete'!
processPostUnknown: request
	" handle a non-standard post type "
	" e.g., text/html "! !
!ComancheModule methodsFor: 'obsolete'!
processPut: request
	" do something "! !
!AccessControlModule commentStamp: 'bolot 7/16/1999 13:26'!
AccessControlModule
- implements access control lists (not yet!!)
- to be effective, must be used before data serving modules
  (say right after DomainFilterModule)
!
!AccessControlModule methodsFor: 'processing'!
process: request
	" check if request action and user are allowed by accessControlList "
	^request! !
!ComancheModule class reorganize!
('instance creation' defaultDirectory newModuleNamed: newModuleNamed:workDir:tempDir:)
('web server packages' basicWebServer standardWebServer)
('obsolete' defaultHandlers)
!
!ComancheModule class methodsFor: 'instance creation'!
defaultDirectory
	| delim |
	delim _ String with: FileDirectory pathNameDelimiter.
	^FileDirectory default pathName , delim , 'www', delim! !
!ComancheModule class methodsFor: 'instance creation'!
newModuleNamed: str
	^self newModuleNamed: str
		workDir: self defaultDirectory
		tempDir: self defaultDirectory, 'temp'! !
!ComancheModule class methodsFor: 'instance creation'!
newModuleNamed: str workDir: workDirPath tempDir: tempDirPath
	^self new initialize;
		privName: str;
		privWorkDirNamed: workDirPath;
		privTempDirNamed: tempDirPath! !
!ComancheModule class methodsFor: 'web server packages'!
basicWebServer
	" create a set of modules that collectively provide
	  a basic set of web services "

	| webServer fileServer uploadServer |
	webServer _ self newModuleNamed: 'comanche'.
" add file server - aka plain vanilla web server "
	fileServer _ FileServerModule newModuleNamed: 'www'.
	uploadServer _ MultipartPostModule newModuleNamed: 'upload'.
	fileServer modules add: uploadServer.
	webServer modules add: fileServer.

	^webServer! !
!ComancheModule class methodsFor: 'web server packages'!
standardWebServer
	" create a set of modules that collectively provide
	  a standard set of web services "

	| webServer |
	webServer _ self basicWebServer.
" add swiki server "
" add admin server "

	^webServer! !
!ComancheModule class methodsFor: 'obsolete'!
defaultHandlers
	" return a Dictionary that maps request to selectors that handle it "
	| dict |
	(dict _ Dictionary new)
	at: 'GET' put: #processGet:;
	at: 'PUT' put: #processPut:;
	at: 'POST' put: #processPost:;
	at: #multipart put: #processPostMultipart:.

	^dict! !
!DomainFilterModule commentStamp: 'bolot 7/16/1999 13:34'!
DomainFilterModule
	allow: ip-pattern, domain-pattern
	deny: ip-pattern, domain-pattern

- to be effective, must be used before any modules
  that write back to the client

- as other service modules, over-rides process:
  thus disabling any use of submodules!
!DomainFilterModule methodsFor: 'processing'!
allow: domainPattern
	(allowedDomains includes: domainPattern)
		ifFalse: [allowedDomains add: domainPattern]! !
!DomainFilterModule methodsFor: 'processing'!
deny: domainPattern
	(deniedDomains includes: domainPattern)
		ifFalse: [deniedDomains add: domainPattern]! !
!DomainFilterModule methodsFor: 'processing'!
process: request
	deniedDomains contains: [:domainPattern |
		(domainPattern match: request remoteAddress)
			ifTrue: [^request abort]].
	^request! !
!FileServerModule methodsFor: 'processing'!
filter: rawRequest
	^FileServerRequest for: self fromRequest: rawRequest! !
!FileServerModule methodsFor: 'processing'!
processAfterModules: request
	| file uploads oldFilename newFilename |
request filename displayAt: 10@10.
	request postFields ifNotNil:
		[uploads _ request postFields select: [:field |
			field isKindOf: MIMEDocument].

		uploads do: [:doc |
			[oldFilename _ doc url pathForFile.
			newFilename _ workDir pathName, FileDirectory pathNameDelimiter asString,
				(doc url pathString findTokens: '/') last.
			tempDir rename: oldFilename toBe: newFilename]
			ifError: [:err :rcvr | " ignore "]]].

	(workDir fileExists: request filename)
		ifFalse: [^request " not found "].
	file _ workDir readOnlyFileNamed: request filename.
	request serveFile: file.
	file close.
	^request! !
!FileServerModule methodsFor: 'processing'!
processPostMultipart: request
	| dict |
Transcript show: request asString; cr.
	dict _ super processPostMultipart: request.
Transcript show: dict asString; cr.
	dict associationsDo: [:a |
		[tempDir
			rename: tempDir pathName, FileDirectory pathNameDelimiter asString, a value
			toBe: workDir pathName, FileDirectory pathNameDelimiter asString, a value]
		ifError: [:err :rcvr | " ignore "]].
	self processGet: request.
	^dict! !
!HttpConnectionQueue methodsFor: 'private'!
block: b
	block _ b! !
!HttpConnectionQueue methodsFor: 'private'!
listenLoop
	" for web servers "

	[true] whileTrue: [
		((socket == nil) and: [connections size < maxQueueLength]) ifTrue: [
			"try to create a new socket for listening"
			socket _ HTTPSocket createIfFail: [nil]].

		socket == nil
			ifTrue: [(Delay forMilliseconds: 100) wait]
			ifFalse: [
				socket isUnconnected ifTrue: [socket listenOn: portNumber].
				socket waitForConnectionUntil: (Socket deadlineSecs: 10).
				socket isConnected
					ifTrue: [  "connection established"
						(server notNil and: [block notNil])
							ifTrue: [block value: server value: socket]
							ifFalse: [accessSema critical: [connections addLast: socket]].
						socket _ nil]
					ifFalse: [
						socket isWaitingForConnection
							ifFalse: [socket destroy. socket _ nil]]].  "broken socket; start over"
		self pruneStaleConnections].
! !
!HttpConnectionQueue methodsFor: 'private'!
server: s
	server _ s! !
!HttpConnectionQueue class methodsFor: 'instance creation'!
portNumber: anInteger queueLength: queueLength server: server block: block

	^ self new initPortNumber: anInteger queueLength: queueLength;
		server: server; block: block
! !
!HttpRequest commentStamp: 'bolot 7/16/1999 13:45'!
HttpRequest
	basic request
	also encapsulates response (? - as of 1999-07-16)!
!HttpRequest methodsFor: 'initialization'!
initialize
	(header _ Dictionary new)
	at: 'content-type' put: MIMEDocument defaultContentType! !
!HttpRequest methodsFor: 'initialization'!
readHeader
	| i getQuery postQuery |
	header _ stream header.
	protocol _ stream status at: #protocol ifAbsent: ['HTTP/1.0'].
	url _ stream status at: #url ifAbsent: [''].
	method _ stream status at: #method ifAbsent: ['GET'].
	cookies _ self class decodeUrlEncodedForm: (header at: 'cookies' ifAbsent: [''])
		fieldDelimiters: ' ;'.
	contentType _ header at: 'content-type' ifAbsent: [].
	contentType ifNotNil: [i _ contentType indexOf: $;.
		i > 0 ifTrue: [contentType _ contentType asLowercase copyFrom: 1 to: i-1]].

	" parse cgi fields in the url, if any "
	(i _ url indexOf: $?) > 0
		ifTrue: [getQuery _ url copyFrom: i+1 to: url size.
			url _ url copyFrom: 1 to: i-1.
			getFields _ self class decodeUrlEncodedForm: getQuery].

	url unescapePercents.

	" parse cgi fields in the body of request, if it's standard form data "
	(method = 'POST' and: [self contentType = MIMEDocument contentTypeFormData])
		ifTrue: [postQuery _ stream upToEnd withBlanksTrimmed.
			postFields _ self class decodeUrlEncodedForm: postQuery]
! !
!HttpRequest methodsFor: 'initialization'!
stream: s
	stream _ s! !
!HttpRequest methodsFor: 'accessing'!
body
	^body! !
!HttpRequest methodsFor: 'accessing'!
contentLength
	^(header at: 'content-length' ifAbsent: [0]) asNumber! !
!HttpRequest methodsFor: 'accessing'!
contentType
	^contentType! !
!HttpRequest methodsFor: 'accessing'!
cookies
	^cookies! !
!HttpRequest methodsFor: 'accessing'!
destroy
	stream close.
	stream _ nil! !
!HttpRequest methodsFor: 'accessing'!
getFields
	^getFields! !
!HttpRequest methodsFor: 'accessing'!
header
	^header! !
!HttpRequest methodsFor: 'accessing'!
method
	^method! !
!HttpRequest methodsFor: 'accessing'!
multipartFormDataBoundary
	| str idx |
	str _ header at: 'content-type' ifAbsent: [''].
	(str asLowercase beginsWith: 'multipart/form-data') ifFalse: [^nil].
	idx _ str indexOf: $=. " Content-Type: multipart/form-data; boundary=----- "
	^(str copyFrom: idx + 1 to: str size)! !
!HttpRequest methodsFor: 'accessing'!
postFields
	^postFields! !
!HttpRequest methodsFor: 'accessing'!
protocol
	^protocol! !
!HttpRequest methodsFor: 'accessing'!
remoteAddress
	^stream remoteAddress! !
!HttpRequest methodsFor: 'accessing'!
responseHeader
	^responseHeader! !
!HttpRequest methodsFor: 'accessing'!
stream
	^stream! !
!HttpRequest methodsFor: 'accessing'!
url
	^url! !
!HttpRequest methodsFor: 'converting'!
printHtmlOn: printStream
	printStream nextPutAll: '<B>', self class name, '</B><UL>'; cr;
		nextPutAll: '<LI><B>URL</B>=', url asString; cr;
		nextPutAll: '<LI><B>protocol</B>=', protocol asString; cr.

	header isEmpty not
		ifTrue: [printStream nextPutAll: '<LI><B>Header</B><UL>'; cr.
			header associationsDo: [:a | printStream nextPutAll: '<LI><B>', a key, '</B>=', a value; cr].
			printStream nextPutAll: '</UL>'; cr].

	(getFields notNil and: [getFields isEmpty not])
		ifTrue: [printStream nextPutAll: '<LI><B>getFields</B><UL>'; cr.
			getFields associationsDo: [:a | printStream nextPutAll: '<LI><B>', a key, '</B>=', a value; cr].
			printStream nextPutAll: '</UL>'; cr].

	(postFields notNil and: [postFields isEmpty not])
		ifTrue: [printStream nextPutAll: '<LI><B>postFields</B><UL>'; cr.
			postFields associationsDo: [:a | printStream nextPutAll: '<LI><B>', a key, '</B>=', a value; cr].
			printStream nextPutAll: '</UL>'; cr].

	printStream
		nextPutAll: '</UL>'; cr.! !
!HttpRequest methodsFor: 'converting'!
printHtmlString
	^String streamContents: [:tempStream | self printHtmlOn: tempStream]
! !
!HttpRequest methodsFor: 'converting'!
printOn: printStream
	printStream nextPutAll: self class name;
		nextPutAll: ' (URL=', url asString;
		nextPutAll: '; protocol=', protocol asString;
		nextPutAll: '; header=', header asString;
		nextPutAll: '; getFields=', getFields asString;
		nextPutAll: '; postFields=', postFields asString;
		nextPutAll: ')'! !
!HttpRequest methodsFor: 'private'!
privBody: b
	body _ b! !
!HttpRequest methodsFor: 'private'!
privContentType: str
	contentType _ str! !
!HttpRequest methodsFor: 'private'!
privCookies: dict
	cookies _ dict! !
!HttpRequest methodsFor: 'private'!
privGetFields: g
	getFields _ g! !
!HttpRequest methodsFor: 'private'!
privHeader: h
	header _ h! !
!HttpRequest methodsFor: 'private'!
privMethod: m
	method _ m! !
!HttpRequest methodsFor: 'private'!
privPostFields: p
	postFields _ p! !
!HttpRequest methodsFor: 'private'!
privProtocol: p
	protocol _ p! !
!HttpRequest methodsFor: 'private'!
privResponseHeader: dict
	responseHeader _ dict! !
!HttpRequest methodsFor: 'private'!
privStream: s
	stream _ s! !
!HttpRequest methodsFor: 'private'!
privUrl: u
	url _ u! !
!HttpRequest methodsFor: 'processing'!
done
	" done if a module indicates early termination situation "
	" or if there is no more processing necessary "

	^false! !
!FileServerRequest methodsFor: 'accessing'!
fileName: str
	filename _ str! !
!FileServerRequest methodsFor: 'accessing'!
filename
	^filename! !
!FileServerRequest methodsFor: 'accessing'!
serveFile: file
	| chunk chunkSize |
	" reply header "
	stream nextPutAll: protocol, ' 200 OK', String crlf;
		nextPutAll: 'Content-type: ', (MIMEDocument guessTypeFromName: file name), String crlf;
		nextPutAll: 'Content-length: ', (file size asString), String crlf;
		nextPutAll: String crlf.
	chunkSize _ 4096.
	[file atEnd]
		whileFalse:
			[chunk _ file next: chunkSize.
			stream nextPutAll: chunk.
			Delay forMilliseconds: 50].! !
!HttpRequest class methodsFor: 'instance creation'!
fromRequest: rawRequest
	^(self new)
		privHeader: rawRequest header;
		privBody: rawRequest body;
		privMethod: rawRequest method;
		privContentType: rawRequest contentType;
		privUrl: rawRequest url;
		privProtocol: rawRequest protocol;
		privGetFields: rawRequest getFields;
		privPostFields: rawRequest postFields;
		privCookies: rawRequest cookies;
		privStream: rawRequest stream! !
!HttpRequest class methodsFor: 'instance creation'!
on: socket
	^self new initialize; stream: (HttpStream on: socket); readHeader! !
!HttpRequest class methodsFor: 'instance creation'!
onStream: stream
	^self new initialize; stream: stream! !
!HttpRequest class methodsFor: 'http stuff'!
decodeUrlEncodedForm: string
	| dict tokens i key value |
	dict _ Dictionary new.
	tokens _ string findTokens: '&'.
	tokens do: [:t |
		i _ t indexOf: $=.
		key _ (key _ t copyFrom: 1 to: i-1) unescapePercents asLowercase.
		value _ (value _ i < t size
			ifTrue: [ t copyFrom: i+1 to: t size ]
			ifFalse: ['']) unescapePercents.
	(dict includesKey: key)
		ifFalse: [ dict at: key put: value ]
		ifTrue: [
			((dict at: key) isKindOf: String)
				ifTrue: [ dict at: key put: (OrderedCollection with: (dict at: key)) ].
			(dict at: key) add: value]].
	^dict! !
!HttpRequest class methodsFor: 'http stuff'!
decodeUrlEncodedForm: string fieldDelimiters: delims
	| dict tokens i key value |
	dict _ Dictionary new.
	tokens _ string findTokens: delims.
	tokens do: [:t |
		i _ t indexOf: $=.
		key _ (key _ t copyFrom: 1 to: i-1) unescapePercents asLowercase.
		value _ (value _ i < t size
			ifTrue: [ t copyFrom: i+1 to: t size ]
			ifFalse: ['']) unescapePercents.
	(dict includesKey: key)
		ifFalse: [ dict at: key put: value ]
		ifTrue: [
			((dict at: key) isKindOf: String)
				ifTrue: [ dict at: key put: (OrderedCollection with: (dict at: key)) ].
			(dict at: key) add: value]].
	^dict! !
!HttpRequest class methodsFor: 'http stuff'!
parseHeader: string
	"divide into basic lines"
	" based on HTTPSocket header: code "
	| lines foldedLines i statusLine status header |
	lines _ string findTokens: String crlf.
	lines isEmpty ifTrue: [^nil].
	statusLine _ (lines first) findTokens: ' '.
	lines _ lines copyFrom: 2 to: lines size.

	"parse the status (pretty trivial right now)"
	statusLine size = 3
		ifTrue: [(status _ Dictionary new)
			at: #method put: statusLine first;
			at: #url put: statusLine second;
			at: #protocol put: statusLine third].

	"fold lines that start with spaces into the previous line"
	foldedLines _ OrderedCollection new.
	lines do: [ :line |
		line first isSeparator ifTrue: [
			foldedLines at: foldedLines size  put: (foldedLines last, line) ]
		ifFalse: [ foldedLines add: line ] ].

	"make a dictionary mapping headers to header contents"
	header _ Dictionary new.
	foldedLines do: [ :line |
		i _ line indexOf: $:.
		i > 0 ifTrue: [
			header
			at: (line copyFrom: 1 to: i-1) asLowercase 
			put: (line copyFrom: i+1 to: line size) withBlanksTrimmed ] ]..

	^header! !
!FileServerRequest class methodsFor: 'instance creation'!
for: module fromRequest: rawRequest
	| request filename |
	(rawRequest url beginsWith: '/', module name)
		ifFalse: [^nil].
	request _ self fromRequest: rawRequest.
	filename _ (FileUrl absoluteFromText: rawRequest url) pathForFile.
	filename _ filename copyFrom: module name size + 1 to: filename size.
	filename _ module directory pathName, filename.
	request fileName: filename.
	^request! !
!HttpResponse class methodsFor: 'instance creation'!
initialize
	(StatusCodeDict _ Dictionary new)
	at: #success put: (Comanche httpVersion, ' 200 OK');
	at: #notFound put: (Comanche httpVersion, ' 404 Not Found');
	at: #unAuthorized put: (Comanche httpVersion, ' 401 Unauthorized')! !
!HttpStream commentStamp: 'bolot 7/16/1999 13:43'!
HttpStream
	stream interface to HttpSocket!
!HttpStream methodsFor: 'initialization'!
header: string
	"divide into basic lines"
	" based on HTTPSocket header: code "
	| lines foldedLines i statusLine |
	lines _ string findTokens: String crlf.
	statusLine _ (lines first) findTokens: ' '.
	lines _ lines copyFrom: 2 to: lines size.

	"parse the status (pretty trivial right now)"
	(status _ Dictionary new)
		at: #method put: statusLine first;
		at: #url put: statusLine second;
		at: #protocol put: statusLine third.

	"fold lines that start with spaces into the previous line"
	foldedLines _ OrderedCollection new.
	lines do: [ :line |
		line first isSeparator ifTrue: [
			foldedLines at: foldedLines size  put: (foldedLines last, line) ]
		ifFalse: [ foldedLines add: line ] ].

	"make a dictionary mapping headers to header contents"
	header _ Dictionary new.
	foldedLines do: [ :line |
		i _ line indexOf: $:.
		i > 0 ifTrue: [
			header
			at: (line copyFrom: 1 to: i-1) asLowercase 
			put: (line copyFrom: i+1 to: line size) withBlanksTrimmed ] ]..
! !
!HttpStream methodsFor: 'initialization'!
initialize
	inDataCount _ outDataCount _ 0! !
!HttpStream methodsFor: 'initialization'!
readHeader
	| headerString dataArray |
	dataArray _ socket getResponseUpTo: String crlf, String crlf.
	headerString _ dataArray at: 1.
	buffer _ dataArray at: 3.
	self header: headerString! !
!HttpStream methodsFor: 'initialization'!
socket: s
	socket _ s! !
!HttpStream methodsFor: 'accessing'!
atEnd
	^socket isConnected not and: [buffer isEmpty]! !
!HttpStream methodsFor: 'accessing'!
close
	socket closeAndDestroy: 30.! !
!HttpStream methodsFor: 'accessing'!
contentLength
	^(header at: 'content-length' ifAbsent: [0]) asNumber! !
!HttpStream methodsFor: 'accessing'!
cr
	self nextPutAll: String crlf! !
!HttpStream methodsFor: 'accessing'!
getSubHeader
	" return a MIME section header "
	| i result string dict |
	string _ buffer.
	buffer _ ''.
	[(i _ string findString: String crlf, String crlf) > 0
		ifTrue: [result _ string copyFrom: 1 to: i-1.
			buffer _ string copyFrom: i to: string size.
			4 timesRepeat: [self next]. " ignore CRLFCRLF "
			^HttpRequest parseHeader: result].
	socket isConnected and: [socket dataAvailable]]
		whileTrue:
	[string _ string, socket getData].
	result _ string.
	dict _ HttpRequest parseHeader: result.
	(dict isNil or: [dict isEmpty]) ifFalse: [4 timesRepeat: [self next]]. " ignore CRLFCRLF "
	^dict! !
!HttpStream methodsFor: 'accessing'!
header
	^header! !
!HttpStream methodsFor: 'accessing'!
next
	| c |
	self atEnd ifTrue: [^nil].
	buffer isEmpty ifTrue: [buffer _ socket getData].
	c _ buffer first.
	buffer _ buffer copyFrom: 2 to: buffer size.
	^c! !
!HttpStream methodsFor: 'accessing'!
next: n
	| string |
	buffer size >= n
		ifTrue: [string _ buffer copyFrom: 1 to: n.
			buffer _ buffer copyFrom: n+1 to: buffer size.
			^string].
	string _ buffer.
	buffer _ ''.
	(socket isConnected not or: [socket dataAvailable not])
		ifTrue: [^string].
	buffer _ socket getData.
	^ string , (self next: (n - string size))! !
!HttpStream methodsFor: 'accessing'!
nextChunk
	| string |
	buffer size > 0
		ifTrue: [string _ buffer. buffer _ ''. ^string]
		ifFalse: [^socket getData]! !
!HttpStream methodsFor: 'accessing'!
nextPut: char
	socket sendData: char asString! !
!HttpStream methodsFor: 'accessing'!
nextPutAll: string
	socket isConnected
		ifTrue: [socket sendData: string]! !
!HttpStream methodsFor: 'accessing'!
putDataBack: string
	buffer _ string, buffer! !
!HttpStream methodsFor: 'accessing'!
remoteAddress
	^socket remoteAddress! !
!HttpStream methodsFor: 'accessing'!
status
	^status! !
!HttpStream methodsFor: 'accessing'!
upTo: delim 
	"Fast version to speed up nextChunk"
	| count |
	buffer _ buffer, self next: 2000.
	(count _ buffer indexOf: delim) > 0 ifTrue: 
		["Found the delimiter part way into buffer"
		^ buffer copyFrom: 1 to: count - 1].
	self atEnd ifTrue:
		["Never found it, and hit end of file"
		^ buffer].
	"Never found it, but there's more..."
	^ buffer , (self upTo: delim)! !
!HttpStream methodsFor: 'accessing'!
upToEnd
	| rest |
	rest _ socket getRestOfBuffer: buffer totalLength: self contentLength.
	buffer _ ''.
	(rest isKindOf: String) ifTrue: [^'']. " error "
	^rest contents
! !
!HttpStream class methodsFor: 'instance creation'!
on: socket
	^self basicNew initialize; socket: socket; readHeader! !
!LogModule methodsFor: 'processing'!
process: request
	super process: request.
	logfile nextPutAll: request printString; cr.
	" TODO: use printToLogFile or such "
	" TODO: use platform-specific EOL "

	^request! !
!MIMEDocument class methodsFor: 'content-types'!
contentTypeFormData
	^'application/x-www-form-urlencoded'! !
!MIMEDocument class methodsFor: 'content-types'!
contentTypeHtml
	^'text/html'! !
!MIMEDocument class methodsFor: 'content-types'!
contentTypeMultipart
	^'multipart/form-data'! !
!MIMEDocument class methodsFor: 'content-types'!
contentTypePlainText
	^'text/plain'! !
!MIMEDocument class methodsFor: 'content-types'!
contentTypeXml
	^'text/xml'! !
!MIMEDocument class methodsFor: 'content-types'!
defaultMIMEdatabase
	| d |
	(d _ Dictionary new)
	at: 'html' put: 'text/html';
	at: 'htm' put: 'text/html';
	at: 'xml' put: 'text/xml';
	at: 'txt' put: 'text/plain';
	at: 'c' put: 'text/plain';
	at: 'gif' put: 'image/gif';
	at: 'jpg' put: 'image/jpeg';
	at: 'jpeg' put: 'image/jpeg';
	at: 'xbm' put: 'image/x-xbitmap';
	at: 'mid' put: 'audio/midi';
	at: 'doc' put: 'application/ms-word-document'.
	^d! !
!MIMEDocument class methodsFor: 'content-types'!
guessTypeFromName: url
	"guesses a content type from the url"
	| extension |
	extension _ url asString.
	(extension includes: $.) ifFalse: [ ^self defaultContentType].

	extension _ (extension findTokens: '.') last asLowercase.

	MIMEdatabase ifNil: [MIMEdatabase _ self defaultMIMEdatabase].
	^ MIMEdatabase at: extension ifAbsent: [self defaultContentType].
! !
!MultipartPostModule commentStamp: 'bolot 7/14/1999 17:22'!
MultipartPostModule
helper module
not a standalone module

sole purpose is to
- read the multipart form
- save results in files

PRE:
- http request with header completed

POST:
- http request with body completed!
!MultipartPostModule methodsFor: 'processing'!
filter: request
	(request method = 'POST' and: [request contentType = MIMEDocument contentTypeMultipart])
		ifTrue: [^request].
	^nil! !
!MultipartPostModule methodsFor: 'processing'!
processBeforeModules: request
	" process multipart stuff "

" TODO: change from using socket to stream "
" TODO: use unique temporary names "
" TODO: save other form data "
" TODO: return MIMEDocument or FileStream
	(or smth with both temp file name, file type) "

	" save files in the temporary directory, with temporary names "

	| hdr body boundary str idx fileName file fieldName contentType formDict doc |
"Transcript show: 'socketDataCount = ', request socketDataCount asString; cr."
	formDict _ Dictionary new.
	boundary _ request multipartFormDataBoundary.
"Transcript show: 'Boundary = ', boundary; cr."
	[hdr _ request stream getSubHeader.
	(hdr isNil or: [hdr isEmpty]) ifTrue: [request privPostFields: formDict. ^request].
"Transcript show: hdr asString; cr."
	str _ (hdr at: 'content-disposition' ifAbsent: ['']).

	fileName _ fieldName _ ''.

	idx _ str findString: 'filename='.
	idx > 0 ifTrue: [fileName _ str copyFrom: idx + 10 to: (str indexOf: $" startingAt: idx+10) - 1].

	idx _ str findString: 'name='.
	idx > 0 ifTrue: [fieldName _ str copyFrom: idx + 6 to: (str indexOf: $" startingAt: idx+6) - 1].

	contentType _ hdr at: 'content-type' ifAbsent: [MIMEDocument defaultContentType].
"Transcript show: 'field=', fieldName; cr; show: 'file=', fileName; cr;
	show: 'content-type=', contentType; cr."

	fileName size > 0
		ifTrue: [fileName _ (fileName findTokens: ':/\') last.
			fileName _ (FileDirectory checkName: fileName fixErrors: true) asLowercase.
			file _ tempDir fileNamed: fileName]
		ifFalse: [file _ WriteStream on: String new].
" TODO: parse regular form data "
" TODO: create IgnoreStream "

"Transcript show: 'reading body...'; cr."
	body _ request stream nextChunk.
" Transcript show: 'init body=', body; cr. "
	[(idx _ body findString: boundary) = 0]
		whileTrue:
			[idx _ body size - boundary size + 1 max: 1.
" Transcript show: 'idx=', idx asString; cr. "
			str _ request stream nextChunk.
" Transcript show: 'str=', str; cr;
	show: 'file=', (body copyFrom: 1 to: idx); cr. "
			file nextPutAll: (body copyFrom: 1 to: idx - 1).
			body _ (body copyFrom: idx to: body size) , str].
	" save the last chunk in the file "
	file nextPutAll: (body copyFrom: 1 to: idx-5). " idx-1 - String crlf size "
	file close.
	doc _ MIMEDocument contentType: contentType content: ''
			url: (String streamContents: [:stream |
				stream nextPutAll: 'file://'.
				(tempDir pathName findTokens: FileDirectory pathNameDelimiter asString)
					do: [:piece |
						stream nextPutAll: piece; nextPut: $/].
				stream nextPutAll: fileName]).
	formDict at: fieldName put: doc.

	request stream putDataBack: (body copyFrom: idx-4 to: body size).
	request stream atEnd or: [hdr isNil]
	] whileFalse.

	request privPostFields: formDict.

	^request! !
!PingModule methodsFor: 'processing'!
filter: rawRequest
	rawRequest method = 'PING'
		ifTrue: [^rawRequest]
		ifFalse: [^nil]! !
!PingModule methodsFor: 'processing'!
process: request
	request stream nextPutAll: 'HTTP/1.1 200 OK', String crlf, String crlf,
		'some statistics in XML format'! !
!PwsModule methodsFor: 'pws api'!
actions
	^PWS actions! !
!PwsModule methodsFor: 'processing'!
filter: rawRequest
	^PwsRequest for: self fromRequest: rawRequest! !
!PwsModule methodsFor: 'processing'!
process: request
	Transcript show: request printString; cr.
	request action process: request! !
!PwsRequest methodsFor: 'pws api'!
fields
	^fields! !
!PwsRequest methodsFor: 'pws api'!
log
	^log! !
!PwsRequest methodsFor: 'pws api'!
log: str
	log nextPutAll: str! !
!PwsRequest methodsFor: 'pws api'!
message
	^message! !
!PwsRequest methodsFor: 'pws api'!
message: array
	message _ array! !
!PwsRequest methodsFor: 'pws api'!
peerName
	^peerName! !
!PwsRequest methodsFor: 'pws api'!
reply: str
	stream nextPutAll: str! !
!PwsRequest methodsFor: 'pws api'!
replyStream: file
	stream serveFile: file! !
!PwsRequest methodsFor: 'pws api'!
userId
	^userId! !
!PwsRequest methodsFor: 'private'!
action
	^action! !
!PwsRequest methodsFor: 'private'!
privAction: str
	action _ str! !
!PwsRequest methodsFor: 'private'!
privFields: dict
	fields _ dict! !
!PwsRequest methodsFor: 'private'!
privMessage: coll
	message _ coll! !
!PwsRequest methodsFor: 'private'!
privPeerName: str
	peerName _ str! !
!PwsRequest methodsFor: 'private'!
privUserId: str
	userId _ str! !
!PwsRequest class methodsFor: 'instance creation'!
for: module fromRequest: rawRequest
	| request fields userId i message |
	message _ rawRequest url findTokens: '/.\?:='.

	(PWS actions includesKey: message first)
		ifFalse: [^nil].

	request _ self fromRequest: rawRequest.

	request getFields
		ifNil: [fields _ Dictionary new]
		ifNotNil: [fields _ request getFields].
	request postFields
		ifNotNil: [request postFields associationsDo: [:a | fields at: a key put: a value]].

	userId _ request header at: 'authorization' ifAbsent: [].
	(userId notNil and: [(i _ userId findString: 'Basic ') > 0])
		ifTrue: [userId _ userId copyFrom: i+6 to: userId size]
		ifFalse: [userId _ nil].

	request
		privFields: fields;
		privMessage: message;
		privUserId: userId;
		privPeerName: nil;
		privAction: (PWS actions at: message first).

	^request! !
Comanche initialize!
